﻿/*
 * Copyright (c) 2015 Razeware LLC
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

using UnityEngine;
using System.Collections;

public class PlayerShooting : MonoBehaviour {

  public Projectile projectilePrefab;
  public LayerMask mask;

	void Update () {
    bool mouseButtonDown = Input.GetMouseButtonDown(0);
    if(mouseButtonDown) {
      raycastOnMouseClick();  
    }
	}

  void raycastOnMouseClick () {
    RaycastHit hit;
    Ray rayToFloor = Camera.main.ScreenPointToRay(Input.mousePosition);

    if(Physics.Raycast(rayToFloor, out hit, 100.0f, mask, QueryTriggerInteraction.Collide)) {
      shoot(hit);
    }
  }

  void shoot(RaycastHit hit){
    var projectile = Instantiate(projectilePrefab).GetComponent<Projectile>();
    var pointAboveFloor = hit.point + new Vector3(0, this.transform.position.y, 0);

    var direction = pointAboveFloor - transform.position;

    var shootRay = new Ray(this.transform.position, direction);

    Physics.IgnoreCollision(GetComponent<Collider>(), projectile.GetComponent<Collider>());
    projectile.FireProjectile(shootRay);
  }
}
